#include <SoftwareSerial.h>
unsigned short sw12;

 // Software serial port to talk to MULTOS
SoftwareSerial gMultosSerial(2, 3); // RX, TX

const unsigned char ISO_CASE_NO_DATA = 1;
const unsigned char ISO_CASE_DATA_OUT = 2;
const unsigned char ISO_CASE_DATA_IN = 3;
const unsigned char ISO_CASE_DATA_IN_OUT = 4;

void setup()
{
  // Main serial port to send messages to IDE
  Serial.begin(9600);

  // Software serial port to talk to MULTOS
  gMultosSerial.begin(9600);
  
  // Select the master file
  sw12 = SelectMF();
  if(sw12 == 0x9000)
    Serial.println("Select MF OK");
  else
    Serial.println("Select MF failed");
  
  // Select the MULTOS application
  sw12 = SelectAppByAID();
  if(sw12 == 0x9000)
    Serial.println("Select App OK");
  else
    Serial.println("Select App failed");  
}

void loop()
{
  unsigned short wLa;
  
  // Flash LED 5 times, 1 second each time
  sw12 = multosSendAPDU (0x70, 0x00, 0x05, 0x01, 0x00, 0x00, &wLa, ISO_CASE_NO_DATA, NULL, 15000);
  if(sw12 == 0x9000)
    Serial.println("APDU OK");
  else
  {
    Serial.print("APDU failed: ");
    Serial.println(sw12, 16);  
  }
    
  // Wait for a bit then do it all again!
  delay(5000);
}

