/*
 * counterv2.c
 *
 *  Created on: 2 Oct 2018
 *      Author: ctorr
 */


// MULTOS running in command mode either through ISO7816 interface or Serial interface(pin 18 low))
// Demonstrates application upgrade retaining static application data

#pragma attribute("aid", "F400000A")
#pragma attribute("access_list", "2403")  // Allow Application Reload + Process Events + Contact interface + strong crypto
#pragma attribute("name","Counter v2")

#include <multos.h>
#include <string.h>

#pragma melpublic
struct  {
	char message[16];
	WORD wCounter;
} result;

#pragma melstatic
char sGreeting[] = "Howdy";
WORD wCounter; // Populate from Counter v1

void
main(void)
{
	BYTE eventId;
	eventId = multosGetProcessEvent();

	// If the application has just been created
	if(eventId == EVENT_CREATE)
	{
		// See if an earlier version exists which allows data to be copied over
		if(multosGetReplacedAppState() == 2)
		{
			// Copy over the data we want. Note, you need to know the location of the data in the old app,
			// which you can get from the disassembly listing. Use hls <appname>.hzx and search for SECTION .SB
			multosCopyStaticFromReplacedApp(6,(BYTE*)&wCounter,sizeof(wCounter));

			// You can also copy from session memory
		}
	}
	// else if an APDU is being executed
	else if (eventId == EVENT_APP_APDU)
	{
		// Run the application.

		// Increment counter
		wCounter++;

		// Return message and counter
		multosClear(18,(BYTE*)&result);
		strcpy(result.message,sGreeting);
		result.wCounter = wCounter;
		La = sizeof(result);
	}
}
