#include <Wire.h>
byte cmd[] =      {0x00, 0x08, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA };
byte expected[] = {0x00, 0x08, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB, 0xAB };
byte reply[18];

#define SLAVE_DEVICE 16

void setup()
{
	// Join I2C bus
	Wire.begin();
	
  Serial.begin(9600);
  Serial.println("Ready");
}

void loop()
{ 
	// Send message
  Serial.println("Sending");
	Wire.beginTransmission(SLAVE_DEVICE);
	Wire.write(cmd,sizeof(cmd));
	Wire.endTransmission();
  
	// 	Get reply
	byte i = 0;
	Wire.requestFrom(SLAVE_DEVICE,sizeof(cmd));
	while (Wire.available())
	{
		reply[i] = Wire.read();
		Serial.print(reply[i],16);
		Serial.print(" ");
		i++;
	}
	Serial.println("");
	
	// Compare to expected reply
	if(memcmp(reply,expected,sizeof(cmd)) == 0)
		Serial.println("Match");
	else
		Serial.println("No match");

  // Wait before doing it again
  delay(10000);
  memset(reply,0,18);
}

